Imports System.Drawing
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls


Public Class WebForm1
    Inherits System.Web.UI.Page
    Protected WithEvents Panel1 As System.Web.UI.WebControls.Panel
		Protected WithEvents lnkNLPlayers As System.Web.UI.WebControls.LinkButton
    Protected WithEvents Label1 As System.Web.UI.WebControls.Label
    Protected WithEvents lnkALPlayers As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkNLRBI As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkNLBattingAverage As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkNLHomeRuns As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkALRBI As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkALHomeRuns As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkALBattingAverage As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkALInnings As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkALERA As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkNLERA As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkALWins As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkNLWins As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkNLInnings As System.Web.UI.WebControls.LinkButton
    Protected WithEvents dropYeaar As System.Web.UI.WebControls.DropDownList
    Protected WithEvents dropYear As System.Web.UI.WebControls.DropDownList
Protected WithEvents gridPlayers As System.Web.UI.WebControls.DataGrid
    Protected WithEvents lnkRegister As System.Web.UI.WebControls.LinkButton
    Protected WithEvents txtEmail As System.Web.UI.WebControls.TextBox
    Protected WithEvents rfvLastName As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents rfvEmail As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents txtLastName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtFirstName As System.Web.UI.WebControls.TextBox
    Protected WithEvents rfvFirstName As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents btnRegister As System.Web.UI.WebControls.Button
    Protected WithEvents pnlMenu As System.Web.UI.WebControls.Panel


#Region " Web Forms Designer Generated Code "
    
    'CODEGEN: This procedure is required by the Web Form Designer
    'Do not modify it using the code editor.
	Private Sub InitializeComponent()

	End Sub

#End Region

    Protected Sub Page_Init(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()

    End Sub

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Call HideRegistration()

    End Sub

    Protected Sub lnkALPlayers_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkALPlayers.Click
        Call ShowALPlayers()
    End Sub

    Protected Sub lnkNLPlayers_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkNLPlayers.Click
        Dim iYear As Integer = CInt(dropYear().SelectedItem.Value)
        gridPlayers().DataSource = New localhost.SuperStats().GetPlayersByLeague("NL", iYear)
        gridPlayers.DataBind()
    End Sub

    Protected Sub lnkALHomeRuns_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkALHomeRuns.Click
        Dim iYear As Integer = CInt(dropYear().SelectedItem.Value)
        gridPlayers().DataSource = New localhost.SuperStats().GetHomeRunLeaders("AL", iYear)
        Page().DataBind()
    End Sub

    Protected Sub lnkNLHomeRuns_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkNLHomeRuns.Click
        Dim iYear As Integer = CInt(dropYear().SelectedItem.Value)
        gridPlayers().DataSource = New localhost.SuperStats().GetHomeRunLeaders("NL", iYear)
        Page().DataBind()
    End Sub

    Protected Sub lnkALBattingAverage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkALBattingAverage.Click
        Dim iYear As Integer = CInt(dropYear().SelectedItem.Value)
        gridPlayers().DataSource = New localhost.SuperStats().GetBattingAverageLeaders("AL", iYear)
        Page().DataBind()
    End Sub

    Protected Sub lnkNLBattingAverage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkNLBattingAverage.Click
        Dim iYear As Integer = CInt(dropYear().SelectedItem.Value)
        gridPlayers().DataSource = New localhost.SuperStats().GetBattingAverageLeaders("NL", iYear)
        Page().DataBind()
    End Sub

    Protected Sub lnkNLRBI_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkNLRBI.Click
        Dim iYear As Integer = CInt(dropYear().SelectedItem.Value)
        gridPlayers().DataSource = New localhost.SuperStats().GetRBILeaders("NL", iYear)
        Page().DataBind()
    End Sub

    Protected Sub lnkALRBI_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkALRBI.Click
        Dim iYear As Integer = CInt(dropYear().SelectedItem.Value)
        gridPlayers().DataSource = New localhost.SuperStats().GetRBILeaders("AL", iYear)
        Page().DataBind()
    End Sub

    Protected Sub lnkALWins_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkALWins.Click
        Dim iYear As Integer = CInt(dropYear().SelectedItem.Value)
        gridPlayers().DataSource = New localhost.SuperStats().GetWinsLeaders("AL", iYear)
        Page().DataBind()
    End Sub

    Protected Sub lnkNLWins_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkNLWins.Click
        Dim iYear As Integer = CInt(dropYear().SelectedItem.Value)
        gridPlayers().DataSource = New localhost.SuperStats().GetWinsLeaders("NL", iYear)
        Page().DataBind()
    End Sub

    Protected Sub lnkALInnings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkALInnings.Click
        Dim iYear As Integer = CInt(dropYear().SelectedItem.Value)
        gridPlayers().DataSource = New localhost.SuperStats().GetInningsLeaders("AL", iYear)
        Page().DataBind()
    End Sub

    Protected Sub lnkALERA_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkALERA.Click
        Dim iYear As Integer = CInt(dropYear().SelectedItem.Value)
        gridPlayers().DataSource = New localhost.SuperStats().GetERALeaders("AL", iYear)
        Page().DataBind()
    End Sub

    Protected Sub lnkNLInnings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkNLInnings.Click
        Dim iYear As Integer = CInt(dropYear().SelectedItem.Value)
        gridPlayers().DataSource = New localhost.SuperStats().GetInningsLeaders("NL", iYear)
        Page().DataBind()
    End Sub

    Protected Sub lnkNLERA_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkNLERA.Click
        Dim iYear As Integer = CInt(dropYear().SelectedItem.Value)
        gridPlayers().DataSource = New localhost.SuperStats().GetERALeaders("NL", iYear)
        Page().DataBind()
    End Sub
    Private Sub HideRegistration()
        txtFirstName().Visible = False
        txtLastName().Visible = False
        txtEmail().Visible = False
        btnRegister().Visible = False
        rfvEmail().Visible = False
        rfvLastName().Visible = False
        rfvFirstName().Visible = False
        gridPlayers().Visible = True

    End Sub
    Private Sub ShowRegistration()
        txtFirstName().Visible = True
        txtLastName().Visible = True
        txtEmail().Visible = True
        btnRegister().Visible = True
        rfvEmail().Visible = True
        rfvLastName().Visible = True
        rfvFirstName().Visible = True
        gridPlayers().Visible = False
    End Sub

    Protected Sub btnRegister_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRegister.Click
        Dim sFirstName As String
        Dim sLastName As String
        Dim sEmail As String

        sFirstName = txtFirstName().Text
        sLastName = txtLastName().Text
        sEmail = txtEmail().Text

        BobsFantasyBaseballDBA.AddRegistration(sFirstName, sLastName, sEmail)

        Call HideRegistration()

        Call ShowALPlayers()
    End Sub

    Protected Sub lnkRegister_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkRegister.Click
        Call ShowRegistration()
    End Sub
    Private Sub ShowALPlayers()
        Dim iYear As Integer = CInt(dropYear().SelectedItem.Value)
        gridPlayers().DataSource = New localhost.SuperStats().GetPlayersByLeague("AL", iYear)
        Page().DataBind()
    End Sub

    Protected Sub dropYear_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dropYear.SelectedIndexChanged
        Response().Write("DropSelected")
    End Sub
End Class
