Module Chapter7
    '***************************************************************************
    'Listing 7.7
    Public Structure Person
        Public FirstName As String
        Public LastName As String
        Public ID As Integer
    End Structure
    '***************************************************************************
    'Listing 7.10
    Public Sub UseConcat()
        Dim sString As String
        sString = "Hello World"
        sString = System.String.ConCat(sString, " ", sString, " ", sString)
        MsgBox(sString)
    End Sub
    Private Function BuildHTMLTable(ByRef statsRecordset As ADODB.Recordset) As String
        Dim sHTMLTable As New System.Text.StringBuilder()
        sHTMLTable.Append("<TABLE>")

        Do Until statsRecordset.EOF
            sHTMLTable.Append("<TR><TD>")
            sHTMLTable.Append(statsRecordset.Fields("PlayerName").Value.ToString.Trim)
            sHTMLTable.Append("</TD><TD>")
            sHTMLTable.Append(statsRecordset.Fields("PlayerAverage").Value.ToString.Trim)
            sHTMLTable.Append("</TD></TR>")
            statsRecordset.MoveNext()
        Loop

        sHTMLTable.Append("<TABLE>")
        Return sHTMLTable.ToString
    End Function

End Module

'***************************************************************************
'Listing 7.17
Public Class COrder

    Private c_lOrderNumber As Long
    Private c_oLineItem As New ClineItem()
    Public ReadOnly Property LineItem() As ClineItem
        Get
            Return c_oLineItem
        End Get
    End Property
    Public Property OrderNumber() As Long
        Get
            OrderNumber = c_lOrderNumber
        End Get

        Set(ByVal Value As Long)
            c_lOrderNumber = Value
        End Set

    End Property
    Public Class ClineItem

        Private c_lProductCode As Long
        Private c_sProductDescription As String

        Friend Sub New()
            MyBase.New()
        End Sub

        Public Property ProductCode() As Long
            Get
                ProductCode = c_lProductCode
            End Get
            Set(ByVal Value As Long)
                c_lProductCode = Value
            End Set
        End Property

        Public Property ProductDescription() As String
            Get
                ProductDescription = c_sProductDescription
            End Get
            Set(ByVal Value As String)
                c_sProductDescription = Value
            End Set
        End Property

    End Class
End Class
'***************************************************************************
'Listing 7.18
Public Structure Employee
    Public FirstName As String
    Public LastName As String
    Public SocialSecurityNumber As String
    Public PirthDate As Date
    Public Dependents As Integer
End Structure
'***************************************************************************
'Listing 7.19
Public Structure TEmployee

    Public FirstName As String
    Public LastName As String
    Private SocialSecurityNumber As String
    Public BirthDate As Date
    Public Dependents As Integer

    ReadOnly Property FullName()
        Get
            Return FirstName & " " & LastName
        End Get
    End Property

    Public Function CalculateExemptionAmount(ByVal AmountPerDependent As Decimal) As Decimal
        Return AmountPerDependent * Dependents
    End Function
End Structure

