Imports System.runtime.InteropServices
Imports System.EnterpriseServices
Namespace Chapter12
    Public Class Chapter12
        '***************************************************************************
        'Listing 12.1
        Private Function GetListBoxItemLength() As Integer
            Const LB_GETITEMLENGTH As Integer = &H18A
            Dim iLength As Integer

            iLength = ListBox1.SendMessage(LB_GETITEMLENGTH, ListBox1.SelectedIndex, 0)
            MsgBox("Length of Selected Item is " & CStr(iLength))
            Return iLength
        End Function

        '***************************************************************************
        'Listing 12.6
        Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Integer, _
        ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As String) As Integer
        '***************************************************************************
        'Listing 12.10
        Overloads Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As Integer) As Integer
        Overloads Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As String) As Integer
        '***************************************************************************
        'Listing 12.6
    Declare Auto Sub CopyFile Lib "Kernel32" (ByVal <MarshalAs(UnmanagedType.LPTStr)> existingfile As String, ByVal <MarshalAs(UnmanagedType.LPTStr)> newfile As String, ByVal failifexists As Boolean)
        '***************************************************************************
        'Listing 12.12
        <StructLayoutAttribute(LayoutKind.Sequential)> Public Structure SystemTime
            Public Year As Short
            Public Month As Short
            Public DayOfWeek As Short
            Public Day As Short
            Public Hour As Short
            Public Minute As Short
            Public Second As Short
            Public Miliseconds As Short
        End Structure
        '***************************************************************************
        'Listing 12.13
        <StructLayoutAttribute(LayoutKind.Explicit)> Public Class SYSTEM_INFO
            <FieldOffset(0)> Private OemId As System.UInt64
            <FieldOffset(4)> Private PageSize As System.UInt64
            <FieldOffset(16)> Private ActiveProcessorMask As System.UInt64
            <FieldOffset(20)> Private NumberOfProcessors As System.UInt64
            <FieldOffset(24)> Private ProcessorType As System.UInt64
        End Class

    End Class
    Public Class Employee
        Private m_sFirstName As String
        Private m_sLastName As String
        Private m_sSSN As String
        Public Property FirstName() As String
            Get
                Return m_sFirstName
            End Get
            Set(ByVal Value As String)
                m_sFirstName = Value
            End Set
        End Property
        Public Property LastName() As String
            Get
                Return m_sLastName
            End Get
            Set(ByVal Value As String)
                m_sLastName = Value
            End Set
        End Property
        Public Property SSN() As String
            Get
                Return m_sSSN
            End Get
            Set(ByVal Value As String)
                m_sSSN = Value
            End Set
        End Property
        Public Function ReverseString(ByVal TheString As String) As String
            Dim sReversedString As String
            Dim i As Integer
            For i = TheString.Length - 1 To 0 Step -1
                sReversedString = sReversedString & TheString.Substring(i, 1)
            Next
            Return sReversedString
        End Function
    End Class
End Namespace