Imports System.EnterpriseServices
Imports System.reflection

<ObjectPoolingAttribute(Enabled:=True, MinPoolSize:=2, MaxPoolSize:=10, CreationTimeout:=20000), _
JustInTimeActivationAttribute(True)> _
Public Class PooledEmployees
    Inherits ServicedComponent

    Private m_oEmployees As DataSet

    Public Function GetEmployees() As DataSet
        Dim oDA As DataAccess
        If m_oEmployees Is Nothing Then
            oda = New DataAccess()
            m_oEmployees = oda.GetEmployees()
        End If
        Return m_oEmployees
    End Function
    Public Overrides Sub Activate()
    End Sub
    Public Overrides Function CanBePooled() As Boolean
        Return True
    End Function
    Public Overrides Sub Deactivate()
    End Sub
End Class
