Imports System.EnterpriseServices
Imports System.reflection


'Event Interface
Public Interface IEmployeeEvents
    Sub EmployeeSaved()
End Interface

'Event Class
<EventClassAttribute(AllowInProcSubscribers:=False, FireInParallel:=True)> _
Public Class EmployeeEvents
    Inherits ServicedComponent
    Implements IEmployeeEvents
    Public Sub EmployeeSaved() Implements IEmployeeEvents.EmployeeSaved
    End Sub
End Class

'Event Sink aka the Client
Public Class EmployeeClient
    Inherits ServicedComponent
    Implements IEmployeeEvents
    Public Sub EmployeeSaved() Implements IEmployeeEvents.EmployeeSaved
        'Do Logic here when the Employee is saved
    End Sub
End Class
