Public Class MaintainBaseBallStatistics
    Inherits System.Windows.Forms.Form
#Region " Class Level Variables "
    Private c_oTeamsAndPlayers As localhost.TeamsAndPlayers
    Private c_oClickedNode As TreeNode
    Private c_oCurrentListItem As ListViewItem
    Private WithEvents c_oTreeViewContextMenu As ContextMenu
    Private WithEvents statStatistics As System.Windows.Forms.StatusBar
    Private WithEvents c_oListViewContextMenu As ContextMenu
    Private c_ostatPanel As StatusBarPanel
#End Region
#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        c_oTreeViewContextMenu() = New ContextMenu()
        treeTeamsAndPlayers().ContextMenu = c_oTreeViewContextMenu()
        c_oListViewContextMenu() = New ContextMenu()
        lvwStatistics().ContextMenu = c_oListViewContextMenu()
        c_ostatPanel = statStatistics().Panels.Add("Ready")
        c_ostatPanel.MinWidth = 200
    End Sub

    'Form overrides dispose to clean up the component list.
    Public Overloads Overrides Sub Dispose()
        MyBase.Dispose()
        If Not (components Is Nothing) Then
            components.Dispose()
        End If
    End Sub
    Private WithEvents treeTeamsAndPlayers As System.Windows.Forms.TreeView
    Private WithEvents mnuNewTeam As System.Windows.Forms.MenuItem
    Private WithEvents mnuNewPlayer As System.Windows.Forms.MenuItem
    Private WithEvents mnuOpenPlayers As System.Windows.Forms.MenuItem
    Private WithEvents mnuExit As System.Windows.Forms.MenuItem
    Private WithEvents mnuLine1 As System.Windows.Forms.MenuItem
    Private WithEvents mnuSave As System.Windows.Forms.MenuItem
    Private WithEvents mnuFile As System.Windows.Forms.MenuItem
    Private WithEvents mnuStatistics As System.Windows.Forms.MainMenu
    Private WithEvents lvwStatistics As System.Windows.Forms.ListView

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.mnuExit = New System.Windows.Forms.MenuItem()
        Me.lvwStatistics = New System.Windows.Forms.ListView()
        Me.mnuNewTeam = New System.Windows.Forms.MenuItem()
        Me.mnuSave = New System.Windows.Forms.MenuItem()
        Me.statStatistics = New System.Windows.Forms.StatusBar()
        Me.mnuStatistics = New System.Windows.Forms.MainMenu()
        Me.mnuFile = New System.Windows.Forms.MenuItem()
        Me.mnuOpenPlayers = New System.Windows.Forms.MenuItem()
        Me.mnuNewPlayer = New System.Windows.Forms.MenuItem()
        Me.mnuLine1 = New System.Windows.Forms.MenuItem()
        Me.treeTeamsAndPlayers = New System.Windows.Forms.TreeView()
        Me.SuspendLayout()
        '
        'mnuExit
        '
        Me.mnuExit.Index = 5
        Me.mnuExit.Text = "Exit"
        '
        'lvwStatistics
        '
        Me.lvwStatistics.BackColor = System.Drawing.Color.FromArgb(CType(255, Byte), CType(255, Byte), CType(192, Byte))
        Me.lvwStatistics.Font = New System.Drawing.Font("Verdana", 8!)
        Me.lvwStatistics.GridLines = True
        Me.lvwStatistics.HideSelection = False
        Me.lvwStatistics.Location = New System.Drawing.Point(152, 0)
        Me.lvwStatistics.MultiSelect = False
        Me.lvwStatistics.Name = "lvwStatistics"
        Me.lvwStatistics.Size = New System.Drawing.Size(696, 584)
        Me.lvwStatistics.TabIndex = 2
        '
        'mnuNewTeam
        '
        Me.mnuNewTeam.Enabled = False
        Me.mnuNewTeam.Index = 2
        Me.mnuNewTeam.Text = "New Team"
        '
        'mnuSave
        '
        Me.mnuSave.Enabled = False
        Me.mnuSave.Index = 3
        Me.mnuSave.Text = "Save"
        '
        'statStatistics
        '
        Me.statStatistics.Location = New System.Drawing.Point(0, 280)
        Me.statStatistics.Name = "statStatistics"
        Me.statStatistics.Size = New System.Drawing.Size(637, 20)
        Me.statStatistics.TabIndex = 3
        '
        'mnuStatistics
        '
        Me.mnuStatistics.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFile})
        '
        'mnuFile
        '
        Me.mnuFile.Index = 0
        Me.mnuFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuOpenPlayers, Me.mnuNewPlayer, Me.mnuNewTeam, Me.mnuSave, Me.mnuLine1, Me.mnuExit})
        Me.mnuFile.Text = "File"
        '
        'mnuOpenPlayers
        '
        Me.mnuOpenPlayers.Index = 0
        Me.mnuOpenPlayers.Text = "Open"
        '
        'mnuNewPlayer
        '
        Me.mnuNewPlayer.Enabled = False
        Me.mnuNewPlayer.Index = 1
        Me.mnuNewPlayer.Text = "New Player"
        '
        'mnuLine1
        '
        Me.mnuLine1.Index = 4
        Me.mnuLine1.Text = "-"
        '
        'treeTeamsAndPlayers
        '
        Me.treeTeamsAndPlayers.Font = New System.Drawing.Font("Verdana", 8!)
        Me.treeTeamsAndPlayers.ImageIndex = -1
        Me.treeTeamsAndPlayers.Name = "treeTeamsAndPlayers"
        Me.treeTeamsAndPlayers.SelectedImageIndex = -1
        Me.treeTeamsAndPlayers.Size = New System.Drawing.Size(152, 584)
        Me.treeTeamsAndPlayers.TabIndex = 1
        '
        'MaintainBaseBallStatistics
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(637, 300)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.statStatistics, Me.lvwStatistics, Me.treeTeamsAndPlayers})
        Me.Menu = Me.mnuStatistics
        Me.Name = "MaintainBaseBallStatistics"
        Me.Text = "Major League Baseball Statistics"
        Me.ResumeLayout(False)

    End Sub
#End Region
#Region " Custom Code"
#Region " TreeView Code"
    Private Sub LoadTreeView()
        Dim oNode As PlayerNode
        Dim oNodePlayers As TreeNode
        Dim oNodeAmericanLeagueTeam As TreeNode
        Dim oNodeNationalLeagueTeam As TreeNode
        Dim oNodeTeam As TeamNode
        Dim oNodeTeamPlayers As TeamPlayersNode
        Dim oNodePlayer As PlayerNode
        Dim oNodePitching As PitchingNode
        Dim oNodeBatting As BattingNode
        Dim oTeamRow As localhost.TeamsAndPlayers.TeamsRow
        Dim oTeamPlayers As localhost.TeamsAndPlayers.TeamPlayersRow
        Dim oPlayerRow As localhost.TeamsAndPlayers.PlayersRow
        Dim oPitchingRow As localhost.TeamsAndPlayers.PitchingStatisticsRow
        Dim oBattingRow As localhost.TeamsAndPlayers.BattingStatisticsRow
        Dim bFound As Boolean

        treeTeamsAndPlayers().Nodes.Clear()
        oNodeAmericanLeagueTeam = treeTeamsAndPlayers().Nodes.Add("American League")
        oNodeNationalLeagueTeam = treeTeamsAndPlayers().Nodes.Add("National League")
        oNodePlayers = treeTeamsAndPlayers().Nodes.Add("Players")

        For Each oTeamRow In c_oTeamsAndPlayers.Teams.Rows

            oNodeTeam = New TeamNode(oTeamRow.ID, oTeamRow.TeamName)

            If oTeamRow.League = "AL" Then
                oNodeAmericanLeagueTeam.ForeColor = System.Drawing.Color.Red
                oNodeAmericanLeagueTeam.Nodes.Add(oNodeTeam)
            Else
                oNodeNationalLeagueTeam.ForeColor = System.Drawing.Color.Blue
                oNodeNationalLeagueTeam.Nodes.Add(oNodeTeam)
            End If

            For Each oTeamPlayers In oTeamRow.GetTeamPlayersRows
                For Each oPlayerRow In c_oTeamsAndPlayers.Players.Rows
                    If oPlayerRow.ID.Equals(oTeamPlayers.PlayerID) Then
                        oNodePlayer = New PlayerNode(oPlayerRow.ID, oPlayerRow.FirstName & " " & oPlayerRow.LastName)
                        oNodeTeam.Nodes.Add(oNodePlayer)

                        If oPlayerRow.GetPitchingStatisticsRows.Length > 0 Then
                            oNodePitching = New PitchingNode(oPlayerRow.ID)
                            oNodePitching.Text = "Pitching"
                            oNodePlayer.Nodes.Add(oNodePitching)
                        End If
                        If oPlayerRow.GetBattingStatisticsRows.Length > 0 Then
                            oNodeBatting = New BattingNode(oPlayerRow.ID)
                            oNodeBatting.Text = "Batting"
                            oNodePlayer.Nodes.Add(oNodeBatting)
                        End If
                    End If
                Next
            Next
        Next

        For Each oPlayerRow In c_oTeamsAndPlayers.Players
            bFound = False
            For Each oNode In oNodePlayers.Nodes
                If oNode.PlayerID.Equals(oPlayerRow.ID) Then
                    bFound = True
                    Exit For
                End If
            Next

            If Not bFound Then
                oNodePlayer = New PlayerNode(oPlayerRow.ID, oPlayerRow.FirstName & " " & oPlayerRow.LastName)
                oNodePlayers.Nodes.Add(oNodePlayer)
            End If
        Next

        mnuNewTeam().Enabled = True
        mnuNewPlayer().Enabled = True
        mnuSave().Enabled = True
    End Sub
    Private Sub treeNodeClicked(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles treeTeamsAndPlayers.AfterSelect

        Dim oTeamNode As TeamNode
        Dim oPlayerNode As PlayerNode
        Dim oPitchNode As PitchingNode
        Dim oBattingNode As BattingNode

        Dim oPitchingRows() As localhost.TeamsAndPlayers.PitchingStatisticsRow
        Dim oPitchingRow As localhost.TeamsAndPlayers.PitchingStatisticsRow
        Dim oBattingRows() As localhost.TeamsAndPlayers.BattingStatisticsRow
        Dim oBattingRow As localhost.TeamsAndPlayers.BattingStatisticsRow

        Dim bRightClick As Boolean

        Try
            c_oClickedNode = e.Node
        Catch exp As Exception
            console.WriteLine(exp.Message)
            Exit Sub
        End Try

        lvwStatistics().Items.Clear()
        lvwStatistics().Columns.Clear()
        lvwStatistics().View = View.Details

        Select Case c_oClickedNode.GetType.ToString
            Case GetType(TeamNode).ToString
                Call BuildPlayerColumns()
                Call LoadTeamPlayersToListView(CType(c_oClickedNode, TeamNode).TeamID)
            Case GetType(PitchingNode).ToString
                Call BuildPitchingStatisticsColumns()
                Call LoadPitchingStatisticsToListView(CType(c_oClickedNode, PitchingNode).PitchingStatisticsID)
            Case GetType(BattingNode).ToString
                Call BuildBattingStatisticsColumns()
                Call LoadBattingStatisticsToListView(CType(c_oClickedNode, BattingNode).BattingStatisticsID)
        End Select
    End Sub

#End Region
#Region " ListView Code"
    Private Sub lvwStatisticsSelected(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvwStatistics.SelectedIndexChanged
        Dim oSelectedItems As ListView.SelectedListViewItemCollection
        oSelectedItems = lvwStatistics().SelectedItems
        If oSelectedItems.Count > 0 Then
            c_oCurrentListItem = oSelectedItems.Item(0)
        Else
            c_oCurrentListItem = Nothing
        End If
    End Sub
    Private Sub LoadPitchingStatisticsToListView(ByVal oPlayerID As System.Guid)
        Dim sWhereClause As String
        Dim oListItem As ListViewItem
        Dim oPitchingStatisticsRows() As localhost.TeamsAndPlayers.PitchingStatisticsRow
        Dim oPitchingStatisticsRow As localhost.TeamsAndPlayers.PitchingStatisticsRow
        Dim oPlayer As localhost.TeamsAndPlayers.PlayersRow

        For Each oPlayer In c_oTeamsAndPlayers.Players
            If oPlayer.ID.Equals(oPlayerID) Then
                For Each oPitchingStatisticsRow In oPlayer.GetPitchingStatisticsRows
                    oListItem = New ListViewItem(oPitchingStatisticsRow.Year.ToString)

                    With oListItem.SubItems
                        .Add(oPitchingStatisticsRow.Games.ToString)
                        .Add(oPitchingStatisticsRow.Starts.ToString)
                        .Add(oPitchingStatisticsRow.Runs.ToString)
                        .Add(oPitchingStatisticsRow.Innings.ToString)
                        .Add(oPitchingStatisticsRow.Wins.ToString)
                        .Add(oPitchingStatisticsRow.Losses.ToString)
                        .Add(oPitchingStatisticsRow.Saves.ToString)
                        .Add((oPitchingStatisticsRow.Runs / (oPitchingStatisticsRow.Innings / 12)).ToString)
                        .Add(oPitchingStatisticsRow.ID.ToString)
                    End With

                    lvwStatistics().Items.Add(oListItem)
                Next

            End If
        Next
    End Sub
    Private Sub LoadBattingStatisticsToListView(ByVal oPlayerID As System.Guid)
        Dim sWhereClause As String
        Dim oListItem As ListViewItem
        Dim oBattingStatisticsRows() As localhost.TeamsAndPlayers.BattingStatisticsRow
        Dim oBattingStatisticsRow As localhost.TeamsAndPlayers.BattingStatisticsRow
        Dim oPlayer As localhost.TeamsAndPlayers.PlayersRow


        For Each oPlayer In c_oTeamsAndPlayers.Players
            If oPlayer.ID.Equals(oPlayerID) Then
                For Each oBattingStatisticsRow In oPlayer.GetBattingStatisticsRows
                    oListItem = New ListViewItem(oBattingStatisticsRow.Year.ToString)

                    With oListItem.SubItems
                        .Add(oBattingStatisticsRow.Games.ToString)
                        .Add(oBattingStatisticsRow.AtBats.ToString)
                        .Add(oBattingStatisticsRow.Hits.ToString)
                        .Add(oBattingStatisticsRow.HomeRuns.ToString)
                        .Add(oBattingStatisticsRow.RBIs.ToString)
                        .Add(CInt(oBattingStatisticsRow.Hits / oBattingStatisticsRow.AtBats * 1000).ToString)
                        .Add(oBattingStatisticsRow.ID.ToString)
                    End With

                    lvwStatistics().Items.Add(oListItem)
                Next
            End If

        Next
    End Sub
    Private Sub LoadTeamPlayersToListView(ByVal oTeamID As System.Guid)

        Dim sWhereClause As String
        Dim oListItem As ListViewItem

        Dim oTeamPlayers() As localhost.TeamsAndPlayers.TeamPlayersRow
        Dim oTeamPlayer As localhost.TeamsAndPlayers.TeamPlayersRow
        Dim oPlayerRows() As localhost.TeamsAndPlayers.PlayersRow
        Dim oPlayer As localhost.TeamsAndPlayers.PlayersRow

        For Each oTeamPlayer In c_oTeamsAndPlayers.TeamPlayers
            If oTeamPlayer.TeamID.Equals(oTeamID) Then

                For Each oPlayer In c_oTeamsAndPlayers.Players
                    If oPlayer.ID.Equals(oTeamPlayer.PlayerID) Then
                        oListItem = New ListViewItem(oPlayer.FirstName)

                        With oListItem.SubItems
                            .Add(oPlayer.LastName)
                            .Add(oPlayer.BirthDate.ToShortDateString)
                            .Add(oPlayer.Height.ToString & " Inches")
                            .Add(oPlayer.Weight.ToString & " lbs")
                            If oPlayer.Throws = False Then
                                .Add("Left")
                            Else
                                .Add("Right")
                            End If
                            If oPlayer.Bats = 0 Then
                                .Add("Right")
                            ElseIf oPlayer.Bats = 1 Then
                                .Add("Left")
                            Else
                                .Add("Switch")
                            End If
                            .Add(FieldingPosition(oPlayer.Position))
                        End With
                        lvwStatistics().Items.Add(oListItem)
                    End If
                Next
            End If
        Next

    End Sub
    Private Function FieldingPosition(ByVal iPosition As Integer) As String
        Select Case iPosition
            Case 0
                Return "Pitcher"
            Case 1
                Return "Catcher"
            Case 1
                Return "First Base"
            Case 3
                Return "Second Base"
            Case 4
                Return "Third Base"
            Case 5
                Return "ShortStop"
            Case 6
                Return "Right Field"
            Case 7
                Return "Center Field"
            Case 8
                Return "Left Field"
            Case 9
                Return "Designated Hitter"
        End Select
    End Function
    Private Sub BuildPlayerColumns()
        With lvwStatistics().Columns
            .Add("First Name", 80, HorizontalAlignment.Left)
            .Add("Last Name", 80, HorizontalAlignment.Left)
            .Add("Birth Date", 80, HorizontalAlignment.Left)
            .Add("Height", 50, HorizontalAlignment.Left)
            .Add("Weight", 50, HorizontalAlignment.Left)
            .Add("Throws", 50, HorizontalAlignment.Left)
            .Add("Bats", 50, HorizontalAlignment.Left)
            .Add("Position", 100, HorizontalAlignment.Left)
        End With
    End Sub
    Private Sub BuildPitchingStatisticsColumns()
        With lvwStatistics().Columns
            .Add("Year", 50, HorizontalAlignment.Left)
            .Add("Games", 50, HorizontalAlignment.Left)
            .Add("Starts", 60, HorizontalAlignment.Left)
            .Add("Runs", 50, HorizontalAlignment.Left)
            .Add("Innings", 60, HorizontalAlignment.Left)
            .Add("Wins", 50, HorizontalAlignment.Left)
            .Add("Losses", 50, HorizontalAlignment.Left)
            .Add("Saves", 50, HorizontalAlignment.Left)
            .Add("ERA", 50, HorizontalAlignment.Left)
            .Add("ID", 0, HorizontalAlignment.Left)
        End With

    End Sub
    Private Sub BuildBattingStatisticsColumns()
        With lvwStatistics().Columns
            .Add("Year", 50, HorizontalAlignment.Left)
            .Add("Games", 50, HorizontalAlignment.Left)
            .Add("At Bats", 60, HorizontalAlignment.Left)
            .Add("Hits", 50, HorizontalAlignment.Left)
            .Add("Home Runs", 80, HorizontalAlignment.Left)
            .Add("RBIs", 50, HorizontalAlignment.Left)
            .Add("Average", 80, HorizontalAlignment.Left)
            .Add("ID", 0, HorizontalAlignment.Left)
        End With
    End Sub
#End Region
#Region " Menu Event Handlers"
    Private Sub mnuOpenPlayers_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOpenPlayers.Click
        Dim oDBA As New localhost.DataBaseAccess()
        c_oTeamsAndPlayers = oDBA.GetTeamsAndPlayers
        CType(c_oTeamsAndPlayers, DataSet).EnforceConstraints = True
        Call LoadTreeView()

    End Sub

    Private Sub mnuNewTeam_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuNewTeam.Click
        Dim oTeamRow As localhost.TeamsAndPlayers.TeamsRow
        Dim oNewTeam As AddUpdateTeam

        oTeamRow = c_oTeamsAndPlayers.Teams.NewTeamsRow()
        oNewTeam = New AddUpdateTeam(oTeamRow)
        oNewTeam.ShowDialog(Me)
        If Not oTeamRow.IsNull(0) Then


            c_oTeamsAndPlayers.Teams.AddTeamsRow(oTeamRow)
            Call LoadTreeView()
        End If
    End Sub
    Private Sub mnuSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSave.Click
        Dim oDBA As New localhost.DataBaseAccess()
        oDBA.UpdateTeamsAndPlayers(c_oTeamsAndPlayers)
    End Sub

    Private Sub mnuNewPlayer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuNewPlayer.Click
        Dim oPlayerRow As localhost.TeamsAndPlayers.PlayersRow
        Dim oNewPlayer As AddUpdatePlayer
        Dim oTeamPlayerRow As localhost.TeamsAndPlayers.TeamPlayersRow

        oPlayerRow = c_oTeamsAndPlayers.Players.NewPlayersRow()
        oNewPlayer = New AddUpdatePlayer(oPlayerRow, c_oTeamsAndPlayers.Teams)
        oNewPlayer.ShowDialog(Me)
        If Not oPlayerRow.IsNull(0) Then

            If oNewPlayer.TeamID.ToString.Length > 0 Then
                oTeamPlayerRow = c_oTeamsAndPlayers.TeamPlayers.NewTeamPlayersRow()
                oTeamPlayerRow.ID = System.Guid.NewGuid
                oTeamPlayerRow.TeamID = oNewPlayer.TeamID
                oTeamPlayerRow.PlayerID = oPlayerRow.ID
                c_oTeamsAndPlayers.TeamPlayers.AddTeamPlayersRow(oTeamPlayerRow)
            End If

            c_oTeamsAndPlayers.Players.AddPlayersRow(oPlayerRow)
            Call LoadTreeView()
        End If
    End Sub
    Private Sub UpdatePlayerMenuSelected(ByVal sender As System.Object, ByVal e As System.EventArgs)

        Dim oPlayerRow As localhost.TeamsAndPlayers.PlayersRow
        Dim oTeamPlayerRow As localhost.TeamsAndPlayers.TeamPlayersRow
        Dim oPlayer As AddUpdatePlayer
        Dim oPlayerNode As PlayerNode
        Dim bFoundTeamPlayerRow As Boolean

        oPlayerNode = CType(c_oClickedNode, PlayerNode)

        For Each oPlayerRow In c_oTeamsAndPlayers.Players
            If oPlayerRow.ID.Equals(oPlayerNode.PlayerID) Then
                Exit For
            End If
        Next

        oPlayer = New AddUpdatePlayer(oPlayerRow, c_oTeamsAndPlayers.Teams)
        For Each oTeamPlayerRow In c_oTeamsAndPlayers.TeamPlayers
            If oPlayerRow.ID.Equals(oTeamPlayerRow.PlayerID) Then
                oPlayer.TeamID = oTeamPlayerRow.TeamID
                bFoundTeamPlayerRow = True
                Exit For
            End If
        Next

        oPlayer.ShowDialog(Me)

        If bFoundTeamPlayerRow Then
            oTeamPlayerRow.TeamID = oPlayer.TeamID
        Else
            oTeamPlayerRow = c_oTeamsAndPlayers.TeamPlayers.NewTeamPlayersRow()
            oTeamPlayerRow.ID = System.Guid.NewGuid
            oTeamPlayerRow.TeamID = oPlayer.TeamID
            oTeamPlayerRow.PlayerID = oPlayerRow.ID
            c_oTeamsAndPlayers.TeamPlayers.AddTeamPlayersRow(oTeamPlayerRow)
        End If
        Call LoadTreeView()

    End Sub
    Private Sub AddPlayerBattingStatistics(ByVal sender As System.Object, ByVal e As System.EventArgs)

        Dim oNewBattingStatistics As localhost.TeamsAndPlayers.BattingStatisticsRow
        Dim oStatistics As AddUpdateBattingStatistics

        oNewBattingStatistics = c_oTeamsAndPlayers.BattingStatistics.NewBattingStatisticsRow()
        oStatistics = New AddUpdateBattingStatistics(oNewBattingStatistics)
        oStatistics.ShowDialog(Me)

        If Not oNewBattingStatistics.IsNull(0) Then
            oNewBattingStatistics.Player = CType(c_oClickedNode, PlayerNode).PlayerID
            If c_oClickedNode.Parent.GetType Is GetType(TeamNode) Then
                oNewBattingStatistics.Team = CType(c_oClickedNode.Parent, TeamNode).TeamID
            Else
                oNewBattingStatistics.Team = c_oTeamsAndPlayers.Players.FindByID(oNewBattingStatistics.Player).ID
            End If
            c_oTeamsAndPlayers.BattingStatistics.AddBattingStatisticsRow(oNewBattingStatistics)

            Call LoadTreeView()
        End If

    End Sub
    Private Sub AddPlayerPitchingStatistics(ByVal sender As System.Object, ByVal e As System.EventArgs)

        Dim oNewPitchingStatistics As localhost.TeamsAndPlayers.PitchingStatisticsRow
        Dim oStatistics As AddUpdatePitchingStatistics

        oNewPitchingStatistics = c_oTeamsAndPlayers.PitchingStatistics.NewPitchingStatisticsRow()
        oStatistics = New AddUpdatePitchingStatistics(oNewPitchingStatistics)
        oStatistics.ShowDialog(Me)

        If Not oNewPitchingStatistics.IsNull(0) Then
            oNewPitchingStatistics.Player = CType(c_oClickedNode, PlayerNode).PlayerID
            oNewPitchingStatistics.Team = CType(c_oClickedNode.Parent, TeamNode).TeamID
            c_oTeamsAndPlayers.PitchingStatistics.AddPitchingStatisticsRow(oNewPitchingStatistics)

            Call LoadTreeView()
        End If


    End Sub
    Private Sub UpdatePlayerBattingStatistics(ByVal sender As System.Object, ByVal e As System.EventArgs)

        Dim oBattingStatistics As localhost.TeamsAndPlayers.BattingStatisticsRow
        Dim oStatistics As AddUpdateBattingStatistics
        Dim oPlayer As localhost.TeamsAndPlayers.PlayersRow
        Dim bFound As Boolean

        For Each oPlayer In c_oTeamsAndPlayers.Players
            If oPlayer.ID.Equals(CType(c_oClickedNode.Parent, PlayerNode).PlayerID) Then
                For Each oBattingStatistics In oPlayer.GetBattingStatisticsRows
                    Console.WriteLine("Row: " & oBattingStatistics.ID.ToString)
                    Console.WriteLine("SubItem: " & c_oCurrentListItem.SubItems(7).ToString)
                    If InStr(1, c_oCurrentListItem.SubItems(7).ToString, oBattingStatistics.ID.ToString) > 0 Then
                        bFound = True
                        Exit For
                    End If
                Next
            End If
        Next

        If bFound Then
            oStatistics = New AddUpdateBattingStatistics(oBattingStatistics)
            oStatistics.ShowDialog(Me)

            Call LoadTreeView()
        End If

    End Sub
    Private Sub UpdatePlayerPitchingStatistics(ByVal sender As System.Object, ByVal e As System.EventArgs)

        Dim oPitchingStatistics As localhost.TeamsAndPlayers.PitchingStatisticsRow
        Dim oStatistics As AddUpdatePitchingStatistics
        Dim oPlayer As localhost.TeamsAndPlayers.PlayersRow

        For Each oPlayer In c_oTeamsAndPlayers.Players
            If oPlayer.ID.Equals(CType(c_oClickedNode.Parent, PlayerNode).PlayerID) Then
                For Each oPitchingStatistics In oPlayer.GetPitchingStatisticsRows
                    If oPitchingStatistics.ID.Equals(c_oCurrentListItem.SubItems(9)) Then
                        Exit For
                    End If
                Next
            End If
        Next

        oStatistics = New AddUpdatePitchingStatistics(oPitchingStatistics)
        oStatistics.ShowDialog(Me)

        Call LoadTreeView()

    End Sub
    Private Sub UpdateTeamMenuSelected(ByVal sender As System.Object, ByVal e As System.EventArgs)

        Dim oTeamRow As localhost.TeamsAndPlayers.TeamsRow
        Dim oTeam As AddUpdateTeam
        Dim oTeamNode As TeamNode

        oTeamNode = CType(c_oClickedNode, TeamNode)

        For Each oTeamRow In c_oTeamsAndPlayers.Teams
            If oTeamRow.ID.Equals(oTeamNode.TeamID) Then
                Exit For
            End If
        Next

        oTeam = New AddUpdateTeam(oTeamRow)

        oTeam.ShowDialog(Me)
        Call LoadTreeView()

    End Sub
#End Region
#Region " Popup MenuSetup"
    Private Sub ListViewPopupHandler(ByVal sender As Object, ByVal e As System.EventArgs) Handles c_oListViewContextMenu.Popup
        Dim oMenuItemUpdateBatting As MenuItem
        Dim oMenuItemUpdatePitching As MenuItem
        If Not c_oCurrentListItem Is Nothing Then
            Select Case c_oClickedNode.GetType.ToString
                Case GetType(BattingNode).ToString
                    oMenuItemUpdateBatting = New MenuItem("Update Batting Statistics", AddressOf UpdatePlayerBattingStatistics)
                    With c_oListViewContextMenu().MenuItems
                        .Clear()
                        .Add(oMenuItemUpdateBatting)
                    End With
                Case GetType(PitchingNode).ToString
                    oMenuItemUpdatePitching = New MenuItem("Update Pitching Statistics", AddressOf UpdatePlayerPitchingStatistics)
                    With c_oListViewContextMenu().MenuItems
                        .Clear()
                        .Add(oMenuItemUpdatePitching)
                    End With
            End Select
        End If
    End Sub
    Private Sub TreeViewPopupHandler(ByVal sender As Object, ByVal e As System.EventArgs) Handles c_oTreeViewContextMenu.Popup
        Dim oMenuItemChangePlayer As MenuItem
        Dim oMenuItemChangeTeam As MenuItem
        Dim oMenuItemAddBatting As MenuItem
        Dim oMenuItemAddPitching As MenuItem

        Select Case c_oClickedNode.GetType.ToString
            Case GetType(TeamNode).ToString
                oMenuItemChangeTeam = New MenuItem("Update Team", AddressOf UpdateTeamMenuSelected)
                With c_oTreeViewContextMenu().MenuItems
                    .Clear()
                    .Add(oMenuItemChangeTeam)
                End With
            Case GetType(PlayerNode).ToString
                If c_oClickedNode.Parent.GetType.ToString = GetType(TeamNode).ToString Then
                    oMenuItemChangePlayer = New MenuItem("Update Player", AddressOf UpdatePlayerMenuSelected)
                    oMenuItemAddBatting = New MenuItem("Add Batting Statistics", AddressOf AddPlayerBattingStatistics)
                    oMenuItemAddPitching = New MenuItem("Add Pitching Statistics", AddressOf AddPlayerPitchingStatistics)
                    With c_oTreeViewContextMenu().MenuItems
                        .Clear()
                        .Add(oMenuItemChangePlayer)
                        .Add(oMenuItemAddBatting)
                        .Add(oMenuItemAddPitching)
                    End With
                End If
        End Select
    End Sub

    Private Sub mnuExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuExit.Click
        Me.Close()
    End Sub
#End Region
#End Region
End Class
