Module Chapter3
   

End Module
'********************************************************************************
'Listing 3.2
Public Class Car
    Public MaximumSpeed As Integer
    Public ModelName As String
    Public Sub Accelerate()
        'Some code to make the car go
    End Sub
    Public Sub Stop()
        'Some code to make the car stop
    End Sub
End Class
'********************************************************************************
'Listing 3.4
Dim oCar As New Car()
oCar = New Car
Dim oCar As Car
oCar = Assembly.CreateInstance(Car)
oCar = System.Activator.CreateInstance(Car,URIToAssembly)
'********************************************************************************
'Listing 3.5
Public Class Person
    Private m_sFirstName As String
    Private m_sLastName As String
    Public Property FirstName() As String
        Get
            FirstName = m_sFirstName
        End Get
        Set(ByVal Value As String)
            m_sFirstName = Value
        End Set
    End Property
    Public Property LastName() As String
        Get
            LastName = m_sLastName
        End Get
        Set(ByVal Value As String)
            m_sLastName = Value
        End Set
    End Property
    ReadOnly Property FullName() As String
        Get
            FullName = m_sLastName & ", " & m_sFirstName
        End Get
    End Property
End Class
'********************************************************************************
'Listing 3.5
Public Class Person
    Private m_sFirstName As String
    Private m_sLastName As String
    Private m_sFullName As String
    Public Property FirstName() As String
        Get
            FirstName = m_sFirstName
        End Get
        Set(ByVal Value As String)
            m_sFirstName = Value
            m_sFullName = m_sLastName & ", " & m_sFirstName
        End Set
    End Property
    Public Property LastName() As String
        Get
            LastName = m_sLastName
        End Get
        Set(ByVal Value As String)
            m_sLastName = Value
            m_sFullName = m_sLastName & ", " & m_sFirstName
        End Set
    End Property
    ReadOnly Property FullName() As String
        Get
            FullName = m_sFirstName
        End Get
    End Property
End Class
'********************************************************************************
'Listing 3.7
Public Class RollerCoaster
    Public Sub Ride()
        Console.WriteLine("Here we go")
        Console.WriteLine("Click, Click ,Click")
        Console.WriteLine("Oh, *&@&#%")
        Console.WriteLine("That was great")
    End Sub
End Class
Public Class MerryGoRound
    Public Sub Ride()
        Console.WriteLine("OK will go on it")
        Console.WriteLine("Nap Time")
        Console.WriteLine("Yea its over")
    End Sub
End Class
'Some code somewhere else in the application:
Private Sub DayAtTheAmusementPark()
    Dim oRollerCoaster As New RollerCoaster()
    Dim oMerryGoRound As New MerryGoRound()
    Call GoOnRide(oRollerCoaster)
    Call GoOnRide(oMerryGoRound)
End Sub
Private Sub GoOnRide(ByVal oRide As Object)
    oRide.Ride()
End Sub
'********************************************************************************
'Listing 3.8
Public Interface IAmusementParkRide
    Sub Ride()
End Interface
Public Class RollerCoaster
    Implements IAmusementParkRide
    Public Sub IAmusementParkRide_Ride()
        Console.WriteLine("Here we go")
        Console.WriteLine("Click, Click ,Click")
        Console.WriteLine("Oh, *&@&#%")
        Console.WriteLine("That was great")
    End Sub
End Class
Public Class MerryGoRound
    Implements IAmusementParkRide
    Public Sub IAmusementParkRide_Ride()
        Console.WriteLine("OK will go on it")
        Console.Writeline("Nap Time")
        Console.WriteLine("Yea its over")
    End Sub
End Class
'Some code somewhere else in the application:
Private Sub DayAtTheAmusementPark()
    Dim oRollerCoaster As New RollerCoaster()
    Dim oMerryGoRound As New MerryGoRound()
    Call GoOnRide(oRollerCoaster)
    Call GoOnRide(oMerryGoRound)
End Sub
Private Sub GoOnRide(ByVal oRide As IAmusementParkRide)
    oRide.Ride()
End Sub
'********************************************************************************
'Listing 3.9
Public Class Person
    Protected c_sFirstName As String
    Protected c_sLastName As String
    MustOverride ReadOnly Property ClassName() As String
            Get
                ClassName = Person
            End Get
        End Property
    NotOverridable ReadOnly Property BaseClassName() As String
        Get
            BaseClassName = "Person"
        End Get
    End Property
        Overidable Public Property FirstName() as String
        Get
            FirstName = c_sFirstName
        End Get
        Set
            c_sFirstName = Value
        End Set
    End Property
    Overidable Public Property LastName() as String
        Get
            LastName = c_sLastName
        End Get
        Set
            c_sLastName = Value
        End Set
    End Property
    Overridable Sub Speak()
        Console.WriteLine("I am " & c_sFirstName & " " & c_sLastName)
        Console.WriteLine(" and I am a Person.")
    End Sub
End Class
'********************************************************************************
'Listing 3.10
Public Class NewPerson
    Inherits Person
    Public MustOverride Overrides ReadOnly Property ClassName() As String
        Get
            ClassName = NewPerson
        End Get
    End Property
    Overrides Sub Speak()
        Console.WriteLine("My name is " & c_sFirstName & " " & c_sLastName)
        Console.WriteLine(" and I am a new person.")
    End Sub
End Public
    '********************************************************************************
    'Listing 3.11
    Private c_oDog As Dog
    Public Property MyDog() As Dog
        Get
            MyDog = c_oDog
        End Get
    End Property
    Public Sub GetADog(ByVal Breed As String, ByVal Name As String)
        c_oDog = New Dog(Breed, Name)
    End Sub
    '********************************************************************************
    'Listing 3.12
    Public Interface IEmployee
        Public Property FirstName() As String
        Public Property LastName() As String
        Public Function ChangeSalary(ByVal PercentageIncrease As Decimal) As Decimal
        Public Event Fired(ByVal ReasonCode As Integer)
    End Interface
    '********************************************************************************
    'Listing 3.13
    Public Class Employee
        Implements IEmployee
        Private c_sFirstName As String
        Private c_sLastName As String
        Private c_dSalary As Decimal
        Private Property IEmployee_FirstName() As String
            Get
                IEmployee_FirstName = c_sFirstName
            End Get
            Set(ByVal Value As String)
                c_sFirstName = value
            End Set
        End Property
        Private Property IEmployee_LastName() As String
            Get
                IEmployee_LastName = c_sLastName
            End Get
            Set(ByVal Value As String)
                c_sLastName = value
            End Set
        End Property
        Private Function IEmployee_ChangeSalary(ByVal PercentageIncrease As Decimal) As Decimal
            Return c_dSalary * (PercentageIncrease / 100)
        End Function
        ' In this example I will not be implementing the eventAlthough this is requiredThe syntax is
        ' complex and for brevity will wait for the section on events
    End Class
    '********************************************************************************
    'Listing 3.14
    Public Class Employee
        Implements IEmployee
        Private c_sFirstName As String
        Private c_sLastName As String
        Private c_dSalary As Decimal
        Public Property FirstNameofEmployee() As String Implements IEmployee.FirstName
            Get
                IEmployee_FirstName = c_sFirstName
            End Get
            Set(ByVal Value As String)
                c_sFirstName = value
            End Set
        End Property
        Public Property LastNameOfEmployee() As String Implements IEmployee.LastName

            Get
                IEmployee_LastName = c_sLastName
            End Get
            Set(ByVal Value As String)
                c_sLastName = value
            End Set
        End Property
        Private Function UpdateSalary(ByVal PercentageIncrease As Decimal) As Decimal Implements IEmployee.ChangeSalary
            Return c_dSalary * (PercentageIncrease / 100)
        End Function
        ' In this example I will not be implementing the eventAlthough this is requiredThe syntax is
        ' complex and for brevity will wait for the section on events
    End Class
    '********************************************************************************
    'Listing 3.17
    Private Function UpdateSalary(ByVal PercentageToChange As Decimal) As Decimal Implements IEmployee.ChangeSalary
        Return c_dSalary * (PercentageToChange / 100)
    End Function
    '********************************************************************************
    'Listing 3.18
    Private Function UpdateSalary((ByVal PercentageToChange as Decimal) as Decimal Implements IEmployee.ChangeSalary, IEmployee2.ChangeSalary
        Return c_dSalary * (PercentageToChange / 100)
    End Function








