Public Class Chapter10
    '*************************************************************************
    'Listing 10.1
    'Iterate through ADO Recordset
    Private Sub IterateAdo()
        Do Until oPublishersRecordset.EOF
            Console.WriteLine(oPublishersRecordset.Fields("pub_name").Value.ToString)
            oPublishersRecordset.MoveNext()
        Loop
    End Sub
    '*************************************************************************
    'Listing 10.2
    'Iterate through ADO.NET OleDbDataReader
    Private Sub IterateDataReader()
        Do Until oPublishersDataReader.Read()
            Console.WriteLine(oPublishersDataReader.GetValue(0).ToString)
        Loop
    End Sub
    '*************************************************************************
    'Listing 10.5
    'Write DataSet information to console
    Private Sub DumpDataSetToConsole()
        Dim oDS As New DataSet()
        Dim oDataRow As DataRow

        oleDbConnection1().Open()
        oleDbDataAdapter1().Fill(oDS, "Customers")
        oleDbConnection1().Close()

        For Each oDataRow In oDS.Tables(0).Rows
            Console.WriteLine(oDataRow.Item("CustomerID").ToString & " " & _
                oDataRow.Item("CompanyName").ToString)
        Next
    End Sub
    '*************************************************************************
    'Listing 10.6
    'Write Strongly Typed DataSet information to console
    Private Sub DumpStronglyTypedDataSetToConsole()
        'Type the DataSet as the Schema based DataSet
        Dim oCustomers As New CustomersOrdersAndOrderDetails()\
        'Type the DataRow as the Schema based DataRow
        Dim oCustomerRow As CustomersOrdersAndOrderDetails.CustomersRow

        oleDbConnection1().Open()
        oleDbDataAdapter1().Fill(oCustomers, "Customers")
        oleDbConnection1().Close()

        For Each oCustomerRow In oCustomers.Customers.Rows
            Console.WriteLine(oCustomerRow.CustomerID.ToString & " " & oCustomerRow.CompanyName)
        Next
    End Sub

End Class
